from btc_testbed.rpc_utils import *
from btc_testbed.docker_utils import *
from btc_testbed.conf import *
import logging
import time
import networkx as nx
import matplotlib.pyplot as plt
import PIL.Image
import webbrowser
from PIL import ImageTk
from sys import argv
from getopt import getopt
from Tkinter import *
from Tkinter import PhotoImage
from influxdb import InfluxDBClient


class App:

    def __init__(self, master):
        frame = Frame(master,width=800,height=600)
        frame.place(x=0, y=0)
        
        img= PhotoImage(file = './bitcoin.gif')
        self.hi_there = Button(frame, text="Begin simulation", command= lambda: run_scenario(client),font=("Verdana", 12),width=21, height=10)
        self.hi_there.place(x=0, y=30)
        self.bar1 = Frame(master,width=420, height=30,bg="blue")
        self.bar1.place(x=380,y=0)
        self.title= Label(frame, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
        self.title.place(x=0,y=0)

	def run_scenario(client):
            

            def tornar():
		    scenarioBtc.destroy()

            def addNode():
                    addNodeBtc=Tk()
                    scenarioBtc.withdraw()
                    addNodeBtc.title("Adding Node")
                    addNodeBtc.resizable(1,1)
                    addNodeBtc.geometry("800x600+100+100")
                    bar1 = Frame(addNodeBtc,width=420, height=30,bg="blue")
                    bar1.place(x=380,y=0)
                    title= Label(addNodeBtc, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
                    title.place(x=0,y=0)
                    textInfo= Text(addNodeBtc, bg="black", fg="lightgreen", font=("Verdana",10),width=70,height=15)
                    textInfo.place(x=10,y=280)

                    def tornar2():
		        addNodeBtc.destroy()
		        scenarioBtc.deiconify()

                    def showInfoAdd():
                        textInfo= Text(addNodeBtc, bg="black", fg="lightgreen", font=("Verdana",10),width=70,height=15)
                        textInfo.place(x=10,y=280)
		        bufferText="Current connections: \n"
                        counter=1
	                for c in reversed(get_containers_names(client)):
	    	            bufferText= bufferText+("    Node {}:  {} ({}) has peers: {} \n".format(counter,c, get_ip_by_container_name(client, c), rpcp_get_peer_ips(client,c)))
                            counter=counter+1 
                        textInfo.insert(END,bufferText)

                    showInfoAdd()
                    sendData()

                    addButton= Button(addNodeBtc, text="Add Node", command = lambda: addNow(),width=21, height=10).place(x=0, y=30)
                    listconnsButton= Button(addNodeBtc, text="List connections", command = lambda: showInfoAdd(),width=21, height=5).place(x=0, y=180)
                    backButton= Button(addNodeBtc, text="Back", command = lambda: tornar2(),width=21, height=5).place(x=605, y=30)
                    
                    def addNow():
                        n = count_containers(client)
                        run_new_node(client, DOCK_NETWORK_NAME, node_num=n)
                        source = DOCK_CONTAINER_NAME_PREFIX + str(n-1)
                        dest = DOCK_CONTAINER_NAME_PREFIX + str(n)
                        rpc_create_connection(client, source, dest)

                        bufferText="  Getting info about existing nodes:\n"
                        textInfo.insert(END,bufferText)
                        logger.info("  Getting info about existing nodes:")
                        time.sleep(5)
                        logger.info("  Nodes:")
                        bufferText="  Nodes:\n"
                        textInfo.insert(END,bufferText)

                        for c in reversed(get_containers_names(client)):
                            ip= get_ip_by_container_name(client, c)
                            bufferText="     {} and have ip: {}\n".format(c,ip)
                            textInfo.insert(END,bufferText)
                            logger.info("     {} and have ip: {}".format(c,ip))
                            rpc = rpc_test_connection(client, c)
                            time.sleep(3)
                            bufferText="  Testing rpc connection: {}\n".format(rpc)
                            textInfo.insert(END,bufferText)
                            logger.info("  Testing rpc connection: {}".format(rpc))
                        containers = get_containers_names(client)
                        bufferText="  I have created {} nodes\n".format(len(containers))
                        textInfo.insert(END,bufferText)
                        logger.info("  I have created {} nodes".format(len(containers)))
                        num_connections = sum([len(rpc_getpeerinfo(client, c)) for c in containers])/2
                        bufferText="  I have created {} connections\n".format(num_connections)
                        textInfo.insert(END,bufferText)
                        logger.info("  I have created {} connections".format(num_connections)) 

                        showInfoAdd()
                        print_connections()    

            def disconnectNode():
                    discNodeBtc=Tk()
                    scenarioBtc.withdraw()
                    discNodeBtc.title("Disconnecting Node")
                    discNodeBtc.resizable(1,1)
                    discNodeBtc.geometry("800x600+100+100")
                    bar1 = Frame(discNodeBtc,width=420, height=30,bg="blue")
                    bar1.place(x=380,y=0)
                    title= Label(discNodeBtc, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
                    title.place(x=0,y=0)

                    def tornar2():
		        discNodeBtc.destroy()
		        scenarioBtc.deiconify()

                    def showInfoDiscon():
                        textInfo= Text(discNodeBtc, bg="black", fg="lightgreen", font=("Verdana",10),width=70,height=15)
                        textInfo.place(x=10,y=280)
		        bufferText="Current connections: \n"
                        counter=1
	                for c in reversed(get_containers_names(client)):
	    	            bufferText= bufferText+("    Node {}:  {} ({}) has peers: {} \n".format(counter,c, get_ip_by_container_name(client, c), rpcp_get_peer_ips(client,c)))
                            counter=counter+1 
                        textInfo.insert(END,bufferText)


                    acceptButton= Button(discNodeBtc, text="Disconnect",font=("Verdana",12), command = lambda: disconnectNow(),width=15, height=7).place(x=300, y=70)
                    listconnsButton= Button(discNodeBtc, text="List connections", command = lambda: showInfoDiscon(),width=21, height=10).place(x=0, y=70)
                    backButton= Button(discNodeBtc, text="Back", command = lambda: tornar2(),width=21, height=5).place(x=605, y=30)
                    print_connections()

                    nf = StringVar(discNodeBtc)
                    fnodeL = Label(discNodeBtc, text="Which of the nodes fails?:",font=("Verdana",12))
                    fnodeL.place(x=20, y=40)
                    fnodeSel = Spinbox(discNodeBtc,textvariable = nf, from_=1, to=count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX),font=("Verdana",12))
                    fnodeSel.place(x=280, y=40)
                    showInfoDiscon()
                    sendData()
                    

                    def disconnectNow():
                        numNode= int(nf.get())
                        if (numNode>0 and numNode<=(count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX))):
                            nodePos= str(numNode-1)
                            nodeToDesc = DOCK_CONTAINER_NAME_PREFIX+nodePos
                            print ('Node to disconnect: {}'.format(nodeToDesc))
                            print("  {} ({}) has peers: {}".format(nodeToDesc, get_ip_by_container_name(client, nodeToDesc), rpcp_get_peer_ips(client,nodeToDesc)))
                        
                            argum= str("'"+str(get_ip_by_container_name(client, nodeToDesc))+"'")
                            print('Ip disconnected Node: {}'.format(argum))
                            for n in rpcp_get_peer_ips(client,nodeToDesc):
                                peer= str(get_container_name_by_ip(client,n[0],DOCK_NETWORK_NAME))
                                print('Peer from disconnect: {}'.format(peer))
                                logger.info("  Disconnecting nodes {} and {}...".format(nodeToDesc,peer))
                    	        disconnect = rpc_call(client, peer, "disconnectnode", arguments= format(argum))
                    	        time.sleep(5)
                            showInfoDiscon()
                        else:
                            print("No existing node!! (Please insert a value > 0)")  
                            bufferText="No existing node!! (Please insert a value > 0)"
                            showInfoDiscon()

            def mine():

                    mineBtc=Tk()
                    scenarioBtc.withdraw()
                    mineBtc.title("Mining")
                    mineBtc.resizable(1,1)
                    mineBtc.geometry("800x600+100+100")
                    bar1 = Frame(mineBtc,width=420, height=30,bg="blue")
                    bar1.place(x=380,y=0)
                    title= Label(mineBtc, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
                    title.place(x=0,y=0)
                    bufferText= ""

                    def tornar2():
		        mineBtc.destroy()
		        scenarioBtc.deiconify()

                    def showInfoMine(mineText):
                        textInfo= Text(mineBtc, bg="black", fg="lightgreen", font=("Verdana",10),width=55,height=17)
                        textInfo.place(x=180,y=250)
                        textInfo.insert(END,mineText)


                    MineButton= Button(mineBtc, text="Mine!", command = lambda: mineNow(),font=("Verdana",12),width=21, height=5).place(x=300, y=110)
                    infoButton= Button(mineBtc, text="Info", command = lambda: info(),width=19, height=10).place(x=0, y=180)
                    hashesButton= Button(mineBtc, text="Best Hash", command = lambda: hashes(),width=19, height=10).place(x=0, y=330)
                    dificultyButton= Button(mineBtc, text="Dificulty", command = lambda: difficult(),width=19, height=10).place(x=0, y=480)
                    backButton= Button(mineBtc, text="Back", command = lambda: tornar2(),width=21, height=5).place(x=605, y=30)

                    nm = StringVar(mineBtc)
                    bm = StringVar(mineBtc)
                    nm.set("1")
                    bm.set("1")
                    fnodeL = Label(mineBtc, text="Which of the nodes mines?:",font=("Verdana",12))
                    fnodeL.place(x=20, y=30)
                    fnodeSel = Spinbox(mineBtc,textvariable = nm, from_=1, to=count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX),font=("Verdana",12))
                    fnodeSel.place(x=290, y=30)
                    fblocksL = Label(mineBtc, text="How many blocks?:",font=("Verdana",12))
                    fblocksL.place(x=20, y=80)
                    fblocksSel = Entry(mineBtc,textvariable = bm,font=("Verdana",12))
                    fblocksSel.place(x=280, y=80)
                    showInfoMine(bufferText)

                    def mineNow():
                        numNode= int(nm.get())
                        if (numNode>0 and numNode<=(count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX))):
                            nodePos= str(numNode-1)
                            nodeToMine = DOCK_CONTAINER_NAME_PREFIX + nodePos
                            argum=bm.get()
                            generate = rpc_call(client, nodeToMine, "generate", arguments=format(argum))
                            blocks_after = rpc_call(client, nodeToMine, "getblockcount")
                            balance_after = rpc_call(client, nodeToMine, "getbalance")
                            diff_after = rpc_call(client, nodeToMine, "getdifficulty")
                            hash_after = rpc_call(client, nodeToMine, "getbestblockhash")
                            connections_after = rpc_call(client, nodeToMine, "getconnectioncount")

                            bufferText="  Node {} is aware of {} blocks and has a balance of {} tbtc.\n Difficult is {} .\n And has {} as the best hash.\n Has {} connections.".format(numNode,blocks_after, balance_after,diff_after,hash_after,connections_after)
                            logger.info("  Node {} is aware of {} blocks and has a balance of {} tbtc.\n Difficult is {} .\n And has {} as the best hash".format(numNode,blocks_after, balance_after,diff_after,hash_after))
                            showInfoMine(bufferText)
                            sendData()

                        else:
                            print("No existing node!! (Please insert a value > 0)")
                            bufferText="No existing node!! (Please insert a value > 0)"
                            showInfoMine(bufferText)

                    def info():
                        bufferText=""
                        sendData()
                        for c in reversed(get_containers_names(client)):
                            blocks_after = rpc_call(client, c, "getblockcount")
                            balance_after = rpc_call(client, c, "getbalance")
                            diff_after = rpc_call(client, c, "getdifficulty")
                            hash_after = rpc_call(client, c, "getbestblockhash")
                            bufferText=bufferText+"  Node {} is aware of {} blocks and has a balance of {} tbtc.\n Difficult is {} .\n And has {} as the best hash.\n\n".format(c,blocks_after, balance_after,diff_after,hash_after)
                            logger.info("  Node {} is aware of {} blocks and has a balance of {} tbtc.\n Difficult is {} .\n And has {} as the best hash".format(c,blocks_after, balance_after,diff_after,hash_after))
                        showInfoMine(bufferText)

                    def hashes():
                        numNode= int(nm.get())
                        if (numNode>0 and numNode<=(count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX))):
                            nodePos= str(numNode-1)
                            nodeToMine = DOCK_CONTAINER_NAME_PREFIX + nodePos
                            
                            blocks_after = rpc_call(client, nodeToMine, "getblockcount")
                            argum=blocks_after
                            balance_after = rpc_call(client, nodeToMine, "getbalance")
                            hash_after = rpc_call(client, nodeToMine, "getbestblockhash")
                            bufferText="  Node {} has {} as the best hash".format(numNode,hash_after)
                            logger.info("  Node {} has {} as the best hash".format(numNode,hash_after))
                            showInfoMine(bufferText)
                            sendData()
                        else:
                            print("No existing node!! (Please insert a value > 0)")
                            bufferText="No existing node!! (Please insert a value > 0)"
                            showInfoMine(bufferText) 

                    def difficult():
                        numNode= int(nm.get())
                        if (numNode>0 and numNode<=(count_containers(client,prefix=DOCK_CONTAINER_NAME_PREFIX))):
                            nodePos= str(numNode-1)
                            nodeToMine = DOCK_CONTAINER_NAME_PREFIX + nodePos
                            argum=bm.get()
                            blocks_after = rpc_call(client, nodeToMine, "getblockcount")
                            balance_after = rpc_call(client, nodeToMine, "getbalance")
                            diff_after = rpc_call(client, nodeToMine, "getdifficulty")
                            bufferText="  Node {} is aware of difficult: {}".format(numNode,diff_after)
                            logger.info("  Node {} is aware of difficult: {}".format(numNode,diff_after))
                            showInfoMine(bufferText)
                            sendData()
                        else:
                            print("No existing node!! (Please insert a value > 0)")
                            bufferText="No existing node!! (Please insert a value > 0)"
                            showInfoMine(bufferText) 



            def stats():

                    statsBtc=Tk()
                    scenarioBtc.withdraw()
                    statsBtc.title("Stats")
                    statsBtc.resizable(1,1)
                    statsBtc.geometry("800x600+100+100")
                    bar1 = Frame(statsBtc,width=420, height=30,bg="blue")
                    bar1.place(x=380,y=0)
                    title= Label(statsBtc, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
                    title.place(x=0,y=0)

                    def tornar2():
		        statsBtc.destroy()
		        scenarioBtc.deiconify()

                    def openBalance():
                        webbrowser.open('http://localhost:3000/d/TkF1Yinmk/btcgraph?refresh=5s&orgId=1&panelId=2&fullscreen&from=1525730400000&to=1525816799999',new=1, autoraise=True)

                    def openBlocks():
                        webbrowser.open('http://localhost:3000/d/TkF1Yinmk/btcgraph?refresh=5s&orgId=1&panelId=4&fullscreen&from=1525730400000&to=1525816799999',new=1, autoraise=True) 
                    def openDiff():
                        webbrowser.open('http://localhost:3000/d/TkF1Yinmk/btcgraph?refresh=5s&orgId=1&panelId=6&fullscreen&from=1525730400000&to=1525816799999',new=1, autoraise=True)
                    def openConnections():
                        webbrowser.open('http://localhost:3000/d/TkF1Yinmk/btcgraph?refresh=5s&panelId=10&fullscreen&orgId=1&from=1525790744393&to=1525816799999',new=1, autoraise=True)


                    balanceButton= Button(statsBtc, text="Balance", command = lambda: openBalance(),width=21, height=10).place(x=0, y=30)
                    blocksButton= Button(statsBtc, text="Blocks", command = lambda: openBlocks(),width=21, height=10).place(x=0, y=180)
                    hashesButton= Button(statsBtc, text="Connections", command = lambda: openConnections(),width=21, height=10).place(x=0, y=330)
                    dificultyButton= Button(statsBtc, text="Dificulty", command = lambda: openDiff(),width=21, height=10).place(x=0, y=480)
                    backButton= Button(statsBtc, text="Back", command = lambda: tornar2(),width=21, height=5).place(x=605, y=30)

            def sendData():
            	
                for c in reversed(get_containers_names(client)):
                    
                    blocks_after = rpc_call(client, c, "getblockcount")
                    balance_after = rpc_call(client, c, "getbalance")
                    diff_after = rpc_call(client, c, "getdifficulty")
                    hash_after = rpc_call(client, c, "getbestblockhash")
                    connections_after = rpc_call(client, c, "getconnectioncount")
                    json_body = [{"measurement": 'balance',"time": (time.strftime('%Y-%m-%d %H:%M:%S')),
"tags": {"node": c},"fields": {"value": balance_after}}]
                    clientDB.write_points(json_body)
                    json_body = [{"measurement": 'blocks',"time": (time.strftime('%Y-%m-%d %H:%M:%S')),
"tags": {"node": c},"fields": {"value": blocks_after}}]
                    clientDB.write_points(json_body)
                    json_body = [{"measurement": 'difficult',"time": (time.strftime('%Y-%m-%d %H:%M:%S')),
"tags": {"node": c},"fields": {"value": diff_after}}]
                    clientDB.write_points(json_body)
                    json_body = [{"measurement": 'bestHash',"time": (time.strftime('%Y-%m-%d %H:%M:%S')),
"tags": {"node": c},"fields": {"value": hash_after}}]
                    clientDB.write_points(json_body)
                    json_body = [{"measurement": 'connections',"time": (time.strftime('%Y-%m-%d %H:%M:%S')),
"tags": {"node": c},"fields": {"value": connections_after}}]
                    clientDB.write_points(json_body)
		    print "Enviado a {}".format(c)


            # Print current connections 
            def print_connections(): 
                logger.info("Current connections:") 
                counter=1
	        for c in reversed(get_containers_names(client)):
	    	    logger.info("    Node {}:  {} ({}) has peers: {}".format(counter,c, get_ip_by_container_name(client, c), rpcp_get_peer_ips(client,c)))
                    counter=counter+1              

            scenarioBtc.deiconify()
            root.destroy()

            # Options buttons
	    addNodeButton= Button(scenarioBtc, text="Add Node", command = lambda: addNode(),width=21, height=10).place(x=0, y=30)
            disconnectNodeButton= Button(scenarioBtc, text="Disconnect node", command = lambda: disconnectNode(),width=21, height=10).place(x=0, y=180)
            mineButton= Button(scenarioBtc, text="Mining", command = lambda: mine(),width=21, height=10).place(x=0, y=330)
            statsButton= Button(scenarioBtc, text="Show Data", command = lambda: stats(),width=21, height=10).place(x=0, y=480)
            backButton= Button(scenarioBtc, text="Exit", command = lambda: tornar(),width=21, height=5).place(x=605, y=30)

	    # Create scenario from graph
	    create_scenario_from_graph_file(client,'./graphs/basic4.graphml')

		

        def create_scenario_from_graph(client, g):
	    """
	    Creates a network with the topology extracted from a graph.

	    Warning: remember to call docker_setup with remove_existing=True or to set the names of the nodes so that they
	    do not overlap with existing ones.

	    :param client: docker client
	    :param g: networkx graph
	    :return:
	    """

	    logging.info("  Graph file contains {} nodes and {} connections".format(len(g.nodes()), len(g.edges())))

	    for node in g.nodes():
		run_new_node(client, node_num=node)

	    time.sleep(5)

	    for edge in g.edges():
		source = DOCK_CONTAINER_NAME_PREFIX + str(edge[0])
		dest = DOCK_CONTAINER_NAME_PREFIX + str(edge[1])
		r = rpc_create_connection(client, source, dest)

	    time.sleep(5)

	    logger.info("  I have created {} nodes".format(len(get_containers_names(client))))

	    containers = get_containers_names(client)
	    num_connections = sum([len(rpc_getpeerinfo(client, c)) for c in containers])/2
	    logger.info("  I have created {} connections".format(num_connections))

	    return


	def create_scenario_from_graph_file(client, graph_file):
	    """
	    Creates a network with the topology extracted from a graphml file.

	    Warning: remember to call docker_setup with remove_existing=True or to set the names of the nodes so that they
	    do not overlap with existing ones.

	    :param client: docker client
	    :param graph_file: .graphml file with the network topology
	    :return:
	    """
	    logger.info("Creating scenario from graph file")
	    g = nx.read_graphml(graph_file, node_type=int)
	    create_scenario_from_graph(client, g)



def docker_setup(build_image=True, create_docker_network=True, remove_existing=True):
    """
    Creates the docker client and optionally:
        - builds docker image
        - creates docker network
        - removes containers from previous deployments

    :param build_image: boolean, whether to build the image
    :param create_docker_network: boolean, whether to create the docker network
    :param remove_existing: boolean, whether to remove already existing containers
    :return: docker client
    """

    logger.info('Setting up docker client')
    client = docker.from_env()
    if build_image:
        logger.info("  Building docker image")
        client.images.build(path=".", tag=DOCK_IMAGE_NAME)
    if create_docker_network:
        logger.info("  Creating network")
        create_network(client)
    if remove_existing:
        logger.info("  Removing existing containers")
        remove_containers(client)
    return client


def close_window():
    scenarioBtc.destroy()
    root.destroy()


if __name__ == '__main__':

    if len(argv) > 1:
        # Get params from call
        _, args = getopt(argv, ['nobuild', 'nonet'])
        build = False if '--nobuild' in args else True
        network = False if '--nonet' in args else True
        remove = False if '--noremove' in args else True
    else:
        build = True
        network = True
        remove = True

    # Configure logging
    
    logger = logging.getLogger()
    logger.setLevel(logging.INFO)

    # create a file handler
    handler = logging.StreamHandler()
    handler.setLevel(logging.INFO)
    logger.addHandler(handler)
    handler = logging.FileHandler(LOG_FILE)
    handler.setLevel(logging.INFO)
    logger.addHandler(handler)
    
    # create a logging format
    formatter = logging.Formatter('%(asctime)s - %(name)s: - %(message)s')
    handler.setFormatter(formatter)

    # create data base
    clientDB = InfluxDBClient('localhost', '8086', 'admin', 'admin', 'btcBD1')
    clientDB.create_database('btcBD1')


    # Root config
    root = Tk()
    root.title("Plataforma per analitzar la Xarxa Bitcoin")
    root.resizable(1,1)
    root.geometry("800x600+100+100")
    app = App(root)

    # Loop config
    scenarioBtc= Tk()
    scenarioBtc.title("Simulator")
    scenarioBtc.resizable(1,1)
    scenarioBtc.geometry("800x600+100+100")
    bar1 = Frame(scenarioBtc,width=420, height=30,bg="blue")
    bar1.place(x=380,y=0)
    title= Label(scenarioBtc, text="PLATFORM TO ANALYZE BITCOIN", font=("Verdana", 14),bg="blue", fg="white")
    title.place(x=0,y=0)
    scenarioBtc.withdraw()
        
    # Create docker client & network
    client = docker_setup(build_image=build, create_docker_network=network, remove_existing=remove)
    
    #Define initial interface  
    exitButton= Button(root, text="Exit", command = close_window,width=21, height=5).place(x=605,y=30)

    # End
    scenarioBtc.mainloop()

    
    
